Attribute VB_Name = "modFAYA"
' FAYA.H (pour Visual Basic)

Public Const ERROR_BASE = &H10000000
    
Public Enum F_RC
    F_ERR_NULL = 0
    F_OK = 0
    F_ERR_NO_HEADER = ERROR_BASE + 1
    F_ERR_INVALID_FILE_SZ = ERROR_BASE + 2
    F_ERR_INVALID_FILE_TYPE = ERROR_BASE + 3
    F_ERR_INVALID_HEADER = ERROR_BASE + 4
    F_ERR_UNEXPECTED_EOF = ERROR_BASE + 5
    F_ERR_COMPRESSED_BMP = ERROR_BASE + 6
    F_ERR_WHILE_WRITING_HEADER = ERROR_BASE + 7
    F_ERR_WHILE_WRITING_DATUM = ERROR_BASE + 8
    F_ERR_CLOSING_FILE = ERROR_BASE + 9
    F_ERR_CANT_COMPUTE_HEADER = ERROR_BASE + 10
    F_ERR_CANT_OPEN_FILE = ERROR_BASE + 11
    
    F_ERR_INVALID_HGLOBAL = ERROR_BASE + 128
    F_ERR_NOT_ENOUGH_GLOBAL_MEM = ERROR_BASE + 129
    
    F_ERR_USER_CANCELED = ERROR_BASE + 1024
    F_ERR_TWAIN_RCERROR = ERROR_BASE + 1025
    F_ERR_BAD_STATUS = ERROR_BASE + 1026
End Enum

Public Type BITMAPINFOHEADER
        biSize  As Long         ' DWORD
        biWidth As Long         ' LONG
        biHeight As Long        ' LONG
        biPlanes As Integer     ' WORD
        biBitCount As Integer   ' WORD
        biCompression As Long   ' DWORD
        biSizeImage As Long     ' DWORD
        biXPelsPerMeter As Long ' LONG
        biYPelsPerMeter As Long ' LONG
        biClrUsed As Long       ' DWORD
        biClrImportant As Long  ' DWORD
End Type

'API memory functions
Public Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long

Public Declare Sub CpyMemValAdrFromRefAdr Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CpyMemRefAdrFromValAdr Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Any, ByVal cbCopy As Long)

Public Declare Sub RtlMoveMem Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

'constants for API memory functions
Private Const GMEM_MOVEABLE = &H2
Private Const GMEM_ZEROINIT = &H40
Private Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)


Public Function FAYA_hDib2BIH(ByVal hDib As Long, ByRef bih As BITMAPINFOHEADER)
    Dim ptr As Long
    ptr = GlobalLock(hDib)
    
    If ptr <> 0 Then
        RtlMoveMem bih, ByVal ptr, Len(bih)
    End If
End Function
